1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY
=$
(cd "$TEST_DIRECTORY" && pwd) ||
exit 1
31 if test -z "$TEST_OUTPUT_DIRECTORY"
33 # Similarly, override this to store the test-results subdir
35 TEST_OUTPUT_DIRECTORY
=$TEST_DIRECTORY
37 GIT_BUILD_DIR
="$TEST_DIRECTORY"/..
39 ################################################################
40 # It appears that people try to run tests without building...
41 "$GIT_BUILD_DIR/git" >/dev
/null
44 echo >&2 'error: you do not seem to have built git yet.'
48 .
"$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
49 export PERL_PATH SHELL_PATH
51 # if --tee was passed, write the output not only to the terminal, but
52 # additionally to the file test-results/$BASENAME.out, too.
53 case "$GIT_TEST_TEE_STARTED, $* " in
55 # do not redirect again
57 *' --tee '*|
*' --va'*|
*' --verbose-log '*)
58 mkdir
-p "$TEST_OUTPUT_DIRECTORY/test-results"
59 BASE
="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
61 # Make this filename available to the sub-process in case it is using
63 GIT_TEST_TEE_OUTPUT_FILE
=$BASE.out
64 export GIT_TEST_TEE_OUTPUT_FILE
66 # Truncate before calling "tee -a" to get rid of the results
67 # from any previous runs.
68 >"$GIT_TEST_TEE_OUTPUT_FILE"
70 (GIT_TEST_TEE_STARTED
=done ${SHELL_PATH} "$0" "$@" 2>&1;
71 echo $?
>"$BASE.exit") |
tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
72 test "$(cat "$BASE.
exit")" = 0
77 # For repeatability, reset the environment to known value.
78 # TERM is sanitized below, after saving color control sequences.
83 export LANG LC_ALL PAGER TZ
85 # A call to "unset" with no arguments causes at least Solaris 10
86 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
87 # deriving from the command substitution clustered with the other
89 unset VISUAL EMAIL LANGUAGE COLUMNS $
("$PERL_PATH" -e '
91 my $ok = join("|", qw(
104 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
105 print join("\n", @vars);
107 unset XDG_CONFIG_HOME
109 GIT_AUTHOR_EMAIL
=author@example.com
110 GIT_AUTHOR_NAME
='A U Thor'
111 GIT_COMMITTER_EMAIL
=committer@example.com
112 GIT_COMMITTER_NAME
='C O Mitter'
113 GIT_MERGE_VERBOSITY
=5
114 GIT_MERGE_AUTOEDIT
=no
115 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
116 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
117 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
120 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
122 export GIT_TRACE_BARE
124 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
126 GIT_INDEX_VERSION
="$TEST_GIT_INDEX_VERSION"
127 export GIT_INDEX_VERSION
130 # Add libc MALLOC and MALLOC_PERTURB test
131 # only if we are not executing the test with valgrind
132 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev
/null ||
133 test -n "$TEST_NO_MALLOC_CHECK"
135 setup_malloc_check
() {
138 teardown_malloc_check
() {
142 setup_malloc_check
() {
143 MALLOC_CHECK_
=3 MALLOC_PERTURB_
=165
144 export MALLOC_CHECK_ MALLOC_PERTURB_
146 teardown_malloc_check
() {
147 unset MALLOC_CHECK_ MALLOC_PERTURB_
151 : ${ASAN_OPTIONS=detect_leaks=0}
154 # Protect ourselves from common misconfiguration to export
155 # CDPATH into the environment
161 case $
(echo $GIT_TRACE |
tr "[A-Z]" "[a-z]") in
169 # A regexp to match 5 and 40 hexdigits
170 _x05
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
171 _x40
="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
174 _z40
=0000000000000000000000000000000000000000
176 EMPTY_TREE
=4b825dc642cb6eb9a060e54bf8d69288fbee4904
177 EMPTY_BLOB
=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
183 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
184 # when case-folding filenames
185 u200c
=$
(printf '\342\200\214')
187 export _x05 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
189 # Each test should start with something like this, after copyright notices:
191 # test_description='Description of this test...
192 # This test checks if command xyzzy does the right thing...
195 test "x$TERM" != "xdumb" && (
197 tput bold
>/dev
/null
2>&1 &&
198 tput setaf
1 >/dev
/null
2>&1 &&
199 tput sgr0
>/dev
/null
2>&1
203 while test "$#" -ne 0
206 -d|
--d|
--de|
--deb|
--debu|
--debug)
208 -i|
--i|
--im|
--imm|
--imme|
--immed|
--immedi|
--immedia|
--immediat|
--immediate)
209 immediate
=t
; shift ;;
210 -l|
--l|
--lo|
--lon|
--long|
--long-|
--long-t|
--long-te|
--long-tes|
--long-test|
--long-tests)
211 GIT_TEST_LONG
=t
; export GIT_TEST_LONG
; shift ;;
213 shift; test "$#" -ne 0 ||
{
214 echo 'error: -r requires an argument' >&2;
217 run_list
=$1; shift ;;
219 run_list
=${1#--*=}; shift ;;
220 -h|
--h|
--he|
--hel|
--help)
222 -v|
--v|
--ve|
--ver|
--verb|
--verbo|
--verbos|
--verbose)
225 verbose_only
=${1#--*=}
227 -q|
--q|
--qu|
--qui|
--quie|
--quiet)
228 # Ignore --quiet under a TAP::Harness. Saying how many tests
229 # passed without the ok/not ok details is always an error.
230 test -z "$HARNESS_ACTIVE" && quiet
=t
; shift ;;
232 with_dashes
=t
; shift ;;
235 --va|
--val|
--valg|
--valgr|
--valgri|
--valgrin|
--valgrind)
242 valgrind_only
=${1#--*=}
245 shift ;; # was handled already
250 GIT_TEST_CHAIN_LINT
=1
253 GIT_TEST_CHAIN_LINT
=0
263 echo "error: unknown test option '$1'" >&2; exit 1 ;;
267 if test -n "$valgrind_only"
269 test -z "$valgrind" && valgrind
=memcheck
270 test -z "$verbose" && verbose_only
="$valgrind_only"
271 elif test -n "$valgrind"
278 # Save the color control sequences now rather than run tput
279 # each time say_color() is called. This is done for two
281 # * TERM will be changed to dumb
282 # * HOME will be changed to a temporary directory and tput
283 # might need to read ~/.terminfo from the original HOME
284 # directory to get the control sequences
285 # Note: This approach assumes the control sequences don't end
286 # in a newline for any terminal of interest (command
287 # substitutions strip trailing newlines). Given that most
288 # (all?) terminals in common use are related to ECMA-48, this
289 # shouldn't be a problem.
290 say_color_error
=$
(tput bold
; tput setaf
1) # bold red
291 say_color_skip
=$
(tput setaf
4) # blue
292 say_color_warn
=$
(tput setaf
3) # brown/yellow
293 say_color_pass
=$
(tput setaf
2) # green
294 say_color_info
=$
(tput setaf
6) # cyan
295 say_color_reset
=$
(tput sgr0
)
296 say_color_
="" # no formatting for normal text
298 test -z "$1" && test -n "$quiet" && return
299 eval "say_color_color=\$say_color_$1"
301 printf "%s\\n" "$say_color_color$*$say_color_reset"
305 test -z "$1" && test -n "$quiet" && return
315 say_color error
"error: $*"
324 if test -n "$HARNESS_ACTIVE"
326 if test "$verbose" = t ||
test -n "$verbose_only"
328 printf 'Bail out! %s\n' \
329 'verbose mode forbidden under TAP harness; try --verbose-log'
334 test "${test_description}" != "" ||
335 error
"Test script did not set test_description."
337 if test "$help" = "t"
339 printf '%s\n' "$test_description"
345 if test "$verbose_log" = "t"
347 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
348 elif test "$verbose" = "t"
352 exec 4>/dev
/null
3>/dev
/null
355 # Send any "-x" output directly to stderr to avoid polluting tests
356 # which capture stderr. We can do this unconditionally since it
357 # has no effect if tracing isn't turned on.
359 # Note that this sets up the trace fd as soon as we assign the variable, so it
360 # must come after the creation of descriptor 4 above. Likewise, we must never
361 # unset this, as it has the side effect of closing descriptor 4, which we
362 # use to show verbose tests to the user.
364 # Note also that we don't need or want to export it. The tracing is local to
365 # this shell, and we would not want to influence any shells we exec.
374 test_external_has_tap
=0
378 if test -n "$GIT_EXIT_OK"
382 echo >&5 "FATAL: Unexpected exit with code $code"
391 # The user-facing functions are loaded from a separate file so that
392 # test_perf subshells can have them too
393 .
"$TEST_DIRECTORY/test-lib-functions.sh"
395 # You are not expected to call test_ok_ and test_failure_ directly, use
396 # the test_expect_* functions instead.
399 test_success
=$
(($test_success + 1))
400 say_color
"" "ok $test_count - $@"
404 test_failure
=$
(($test_failure + 1))
405 say_color error
"not ok $test_count - $1"
407 printf '%s\n' "$*" |
sed -e 's/^/# /'
408 test "$immediate" = "" ||
{ GIT_EXIT_OK
=t
; exit 1; }
411 test_known_broken_ok_
() {
412 test_fixed
=$
(($test_fixed+1))
413 say_color error
"ok $test_count - $@ # TODO known breakage vanished"
416 test_known_broken_failure_
() {
417 test_broken
=$
(($test_broken+1))
418 say_color warn
"not ok $test_count - $@ # TODO known breakage"
422 test "$debug" = "" ||
eval "$1"
425 match_pattern_list
() {
428 test -z "$*" && return 1
439 match_test_selector_list
() {
444 test -z "$1" && return 0
446 # Both commas and whitespace are accepted as separators.
452 # If the first selector is negative we include by default.
460 orig_selector
=$selector
466 selector
=${selector##?}
470 test -z "$selector" && continue
474 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev
/null
476 echo "error: $title: invalid non-numeric in range" \
477 "start: '$orig_selector'" >&2
480 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev
/null
482 echo "error: $title: invalid non-numeric in range" \
483 "end: '$orig_selector'" >&2
488 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev
/null
490 echo "error: $title: invalid non-numeric in test" \
491 "selector: '$orig_selector'" >&2
496 # Short cut for "obvious" cases
497 test -z "$include" && test -z "$positive" && continue
498 test -n "$include" && test -n "$positive" && continue
502 if test $arg -le ${selector#-}
508 if test $arg -ge ${selector%-}
514 if test ${selector%%-*} -le $arg \
515 && test $arg -le ${selector#*-}
521 if test $arg -eq $selector
532 maybe_teardown_verbose
() {
533 test -z "$verbose_only" && return
534 exec 4>/dev
/null
3>/dev
/null
539 maybe_setup_verbose
() {
540 test -z "$verbose_only" && return
541 if match_pattern_list
$test_count $verbose_only
544 # Emit a delimiting blank line when going from
545 # non-verbose to verbose. Within verbose mode the
546 # delimiter is printed by test_expect_*. The choice
547 # of the initial $last_verbose is such that before
548 # test 1, we do not print it.
549 test -z "$last_verbose" && echo >&3 ""
552 exec 4>/dev
/null
3>/dev
/null
555 last_verbose
=$verbose
558 maybe_teardown_valgrind
() {
559 test -z "$GIT_VALGRIND" && return
560 GIT_VALGRIND_ENABLED
=
563 maybe_setup_valgrind
() {
564 test -z "$GIT_VALGRIND" && return
565 if test -z "$valgrind_only"
567 GIT_VALGRIND_ENABLED
=t
570 GIT_VALGRIND_ENABLED
=
571 if match_pattern_list
$test_count $valgrind_only
573 GIT_VALGRIND_ENABLED
=t
578 test "$trace" = t
&& test "$verbose" = t
581 # This is a separate function because some tests use
582 # "return" to end a test_expect_success block early
583 # (and we want to make sure we run any cleanup like
585 test_eval_inner_
() {
586 # Do not add anything extra (including LF) after '$*'
593 # We run this block with stderr redirected to avoid extra cruft
594 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
595 # the shell from printing the "set +x" to turn it off (nor the saving
596 # of $? before that). But we can make sure that the output goes to
599 # The test itself is run with stderr put back to &4 (so either to
600 # /dev/null, or to the original stderr if --verbose was used).
602 test_eval_inner_
"$@" </dev
/null
>&3 2>&4
607 if test "$test_eval_ret_" != 0
609 say_color error
>&4 "error: last command exited with \$?=$test_eval_ret_"
613 return $test_eval_ret_
620 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
621 # turn off tracing for this test-eval, as it simply creates
622 # confusing noise in the "-x" output
625 # 117 is magic because it is unlikely to match the exit
626 # code of other programs
627 test_eval_
"(exit 117) && $1"
628 if test "$?" != 117; then
629 error
"bug in the test script: broken &&-chain: $1"
637 teardown_malloc_check
639 if test -z "$immediate" ||
test $eval_ret = 0 ||
640 test -n "$expecting_failure" && test "$test_cleanup" != ":"
643 test_eval_
"$test_cleanup"
644 teardown_malloc_check
646 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
654 test_count
=$
(($test_count+1))
661 maybe_teardown_valgrind
662 maybe_teardown_verbose
668 if match_pattern_list
$this_test.
$test_count $GIT_SKIP_TESTS
671 skipped_reason
="GIT_SKIP_TESTS"
673 if test -z "$to_skip" && test -n "$test_prereq" &&
674 ! test_have_prereq
"$test_prereq"
679 if test "$missing_prereq" != "$test_prereq"
681 of_prereq
=" of $test_prereq"
683 skipped_reason
="missing $missing_prereq${of_prereq}"
685 if test -z "$to_skip" && test -n "$run_list" &&
686 ! match_test_selector_list
'--run' $test_count "$run_list"
689 skipped_reason
="--run"
694 say_color skip
>&3 "skipping test: $@"
695 say_color skip
"ok $test_count # skip $1 ($skipped_reason)"
704 # stub; perf-lib overrides it
705 test_at_end_hook_
() {
712 if test -z "$HARNESS_ACTIVE"
714 test_results_dir
="$TEST_OUTPUT_DIRECTORY/test-results"
715 mkdir
-p "$test_results_dir"
717 test_results_path
="$test_results_dir/${base%.sh}.counts"
719 cat >"$test_results_path" <<-EOF
721 success $test_success
729 if test "$test_fixed" != 0
731 say_color error
"# $test_fixed known breakage(s) vanished; please update test(s)"
733 if test "$test_broken" != 0
735 say_color warn
"# still have $test_broken known breakage(s)"
737 if test "$test_broken" != 0 ||
test "$test_fixed" != 0
739 test_remaining
=$
(( $test_count - $test_broken - $test_fixed ))
740 msg
="remaining $test_remaining test(s)"
742 test_remaining
=$test_count
743 msg
="$test_count test(s)"
745 case "$test_failure" in
747 # Maybe print SKIP message
748 if test -n "$skip_all" && test $test_count -gt 0
750 error
"Can't use skip_all after running some tests"
752 test -z "$skip_all" || skip_all
=" # SKIP $skip_all"
754 if test $test_external_has_tap -eq 0
756 if test $test_remaining -gt 0
758 say_color pass
"# passed all $msg"
760 say
"1..$test_count$skip_all"
763 test -d "$remove_trash" &&
764 cd "$(dirname "$remove_trash")" &&
765 rm -rf "$(basename "$remove_trash")"
772 if test $test_external_has_tap -eq 0
774 say_color error
"# failed $test_failure among $msg"
783 if test -n "$valgrind"
787 test "$1" = "$(readlink "$2")" ||
{
795 while test -d "$2".lock
797 say
"Waiting for lock on $2."
804 make_valgrind_symlink
() {
805 # handle only executables, unless they are shell libraries that
806 # need to be in the exec-path.
808 test "# " = "$(head -c 2 <"$1")" ||
811 base
=$
(basename "$1")
814 symlink_target
="$GIT_BUILD_DIR/t/helper/$base"
817 symlink_target
="$GIT_BUILD_DIR/$base"
820 # do not override scripts
821 if test -x "$symlink_target" &&
822 test ! -d "$symlink_target" &&
823 test "#!" != "$(head -c 2 < "$symlink_target")"
825 symlink_target
=..
/valgrind.sh
829 symlink_target
=..
/unprocessed-script
831 # create the link, or replace it if it is out of date
832 make_symlink
"$symlink_target" "$GIT_VALGRIND/bin/$base" ||
exit
835 # override all git executables in TEST_DIRECTORY/..
836 GIT_VALGRIND
=$TEST_DIRECTORY/valgrind
837 mkdir
-p "$GIT_VALGRIND"/bin
838 for file in $GIT_BUILD_DIR/git
* $GIT_BUILD_DIR/t
/helper
/test-
*
840 make_valgrind_symlink
$file
842 # special-case the mergetools loadables
843 make_symlink
"$GIT_BUILD_DIR"/mergetools
"$GIT_VALGRIND/bin/mergetools"
848 ls "$path"/git-
* 2> /dev
/null |
851 make_valgrind_symlink
"$file"
855 PATH
=$GIT_VALGRIND/bin
:$PATH
856 GIT_EXEC_PATH
=$GIT_VALGRIND/bin
858 GIT_VALGRIND_MODE
="$valgrind"
859 export GIT_VALGRIND_MODE
860 GIT_VALGRIND_ENABLED
=t
861 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED
=
862 export GIT_VALGRIND_ENABLED
863 elif test -n "$GIT_TEST_INSTALLED"
865 GIT_EXEC_PATH
=$
($GIT_TEST_INSTALLED/git
--exec-path) ||
866 error
"Cannot run git from $GIT_TEST_INSTALLED."
867 PATH
=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
868 GIT_EXEC_PATH
=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
869 else # normal case, use ../bin-wrappers only unless $with_dashes:
870 git_bin_dir
="$GIT_BUILD_DIR/bin-wrappers"
871 if ! test -x "$git_bin_dir/git"
873 if test -z "$with_dashes"
875 say
"$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
879 PATH
="$git_bin_dir:$PATH"
880 GIT_EXEC_PATH
=$GIT_BUILD_DIR
881 if test -n "$with_dashes"
883 PATH
="$GIT_BUILD_DIR:$PATH"
886 GIT_TEMPLATE_DIR
="$GIT_BUILD_DIR"/templates
/blt
887 GIT_CONFIG_NOSYSTEM
=1
889 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
891 if test -z "$GIT_TEST_CMP"
893 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
895 GIT_TEST_CMP
="$DIFF -c"
897 GIT_TEST_CMP
="$DIFF -u"
901 GITPERLLIB
="$GIT_BUILD_DIR"/perl
/blib
/lib
:"$GIT_BUILD_DIR"/perl
/blib
/arch
/auto
/Git
903 test -d "$GIT_BUILD_DIR"/templates
/blt ||
{
904 error
"You haven't built things yet, have you?"
907 if ! test -x "$GIT_BUILD_DIR"/t
/helper
/test-chmtime
909 echo >&2 'You need to build test-chmtime:'
910 echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory'
915 TRASH_DIRECTORY
="trash directory.$(basename "$0" .sh)"
916 test -n "$root" && TRASH_DIRECTORY
="$root/$TRASH_DIRECTORY"
917 case "$TRASH_DIRECTORY" in
918 /*) ;; # absolute path is good
919 *) TRASH_DIRECTORY
="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
921 test ! -z "$debug" || remove_trash
=$TRASH_DIRECTORY
922 rm -fr "$TRASH_DIRECTORY" ||
{
924 echo >&5 "FATAL: Cannot prepare test area"
928 HOME
="$TRASH_DIRECTORY"
929 GNUPGHOME
="$HOME/gnupg-home-not-used"
930 export HOME GNUPGHOME
932 if test -z "$TEST_NO_CREATE_REPO"
934 test_create_repo
"$TRASH_DIRECTORY"
936 mkdir
-p "$TRASH_DIRECTORY"
938 # Use -P to resolve symlinks in our working directory so that the cwd
939 # in subprocesses like git equals our $PWD (for pathname comparisons).
940 cd -P "$TRASH_DIRECTORY" ||
exit 1
943 this_test
=${this_test%%-*}
944 if match_pattern_list
"$this_test" $GIT_SKIP_TESTS
946 say_color info
>&3 "skipping test $this_test altogether"
947 skip_all
="skip all tests in $this_test"
951 # Provide an implementation of the 'yes' utility
968 # Fix some commands on Windows
972 # Windows has its own (incompatible) sort and find
982 # git sees Windows-style pwd
986 # no POSIX permissions
987 # backslashes in pathspec are converted to '/'
988 # exec does not inherit the PID
989 test_set_prereq MINGW
990 test_set_prereq NATIVE_CRLF
991 test_set_prereq SED_STRIPS_CR
992 test_set_prereq GREP_STRIPS_CR
993 GIT_TEST_CMP
=mingw_test_cmp
996 test_set_prereq POSIXPERM
997 test_set_prereq EXECKEEPSPID
998 test_set_prereq CYGWIN
999 test_set_prereq SED_STRIPS_CR
1000 test_set_prereq GREP_STRIPS_CR
1003 test_set_prereq POSIXPERM
1004 test_set_prereq BSLASHPSPEC
1005 test_set_prereq EXECKEEPSPID
1009 ( COLUMNS
=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1010 test -z "$NO_PERL" && test_set_prereq PERL
1011 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1012 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1013 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1015 # Can we rely on git's output in the C locale?
1016 if test -n "$GETTEXT_POISON"
1018 GIT_GETTEXT_POISON
=YesPlease
1019 export GIT_GETTEXT_POISON
1020 test_set_prereq GETTEXT_POISON
1022 test_set_prereq C_LOCALE_OUTPUT
1025 # Use this instead of test_cmp to compare files that contain expected and
1026 # actual output from git commands that can be translated. When running
1027 # under GETTEXT_POISON this pretends that the command produced expected
1030 test -n "$GETTEXT_POISON" || test_cmp
"$@"
1033 # Use this instead of "grep expected-string actual" to see if the
1034 # output from a git command that can be translated either contains an
1035 # expected string, or does not contain an unwanted one. When running
1036 # under GETTEXT_POISON this pretends that the command produced expected
1039 if test -n "$GETTEXT_POISON"
1042 elif test "x!" = "x$1"
1051 test_lazy_prereq PIPE
'
1052 # test whether the filesystem supports FIFOs
1058 rm -f testfifo && mkfifo testfifo
1063 test_lazy_prereq SYMLINKS
'
1064 # test whether the filesystem supports symbolic links
1065 ln -s x y && test -h y
1068 test_lazy_prereq FILEMODE
'
1069 test "$(git config --bool core.filemode)" = true
1072 test_lazy_prereq CASE_INSENSITIVE_FS
'
1073 echo good >CamelCase &&
1074 echo bad >camelcase &&
1075 test "$(cat CamelCase)" != good
1078 test_lazy_prereq UTF8_NFD_TO_NFC
'
1079 # check whether FS converts nfd unicode to nfc
1080 auml=$(printf "\303\244")
1081 aumlcdiar=$(printf "\141\314\210")
1091 test_lazy_prereq AUTOIDENT
'
1092 sane_unset GIT_AUTHOR_NAME &&
1093 sane_unset GIT_AUTHOR_EMAIL &&
1094 git var GIT_AUTHOR_IDENT
1097 test_lazy_prereq EXPENSIVE
'
1098 test -n "$GIT_TEST_LONG"
1101 test_lazy_prereq USR_BIN_TIME
'
1102 test -x /usr/bin/time
1105 test_lazy_prereq NOT_ROOT
'
1110 test_lazy_prereq JGIT
'
1114 # SANITY is about "can you correctly predict what the filesystem would
1115 # do by only looking at the permission bits of the files and
1116 # directories?" A typical example of !SANITY is running the test
1117 # suite as root, where a test may expect "chmod -r file && cat file"
1118 # to fail because file is supposed to be unreadable after a successful
1119 # chmod. In an environment (i.e. combination of what filesystem is
1120 # being used and who is running the tests) that lacks SANITY, you may
1121 # be able to delete or create a file when the containing directory
1122 # doesn't have write permissions, or access a file even if the
1123 # containing directory doesn't have read or execute permissions.
1125 test_lazy_prereq SANITY
'
1126 mkdir SANETESTD.1 SANETESTD.2 &&
1128 chmod +w SANETESTD.1 SANETESTD.2 &&
1129 >SANETESTD.1/x 2>SANETESTD.2/x &&
1130 chmod -w SANETESTD.1 &&
1131 chmod -r SANETESTD.1/x &&
1132 chmod -rx SANETESTD.2 ||
1133 error "bug in test sript: cannot prepare SANETESTD"
1135 ! test -r SANETESTD.1/x &&
1136 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1139 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1140 rm -rf SANETESTD.1 SANETESTD.2 ||
1141 error "bug in test sript: cannot clean SANETESTD"
1145 test FreeBSD
!= $uname_s || GIT_UNZIP
=${GIT_UNZIP:-/usr/local/bin/unzip}
1146 GIT_UNZIP
=${GIT_UNZIP:-unzip}
1147 test_lazy_prereq UNZIP
'
1152 run_with_limited_cmdline
() {
1153 (ulimit -s 128 && "$@")
1156 test_lazy_prereq CMDLINE_LIMIT
'run_with_limited_cmdline true'
1159 git version
--build-options |
1160 sed -ne "s/^$1: //p"
1163 test_lazy_prereq LONG_IS_64BIT
'
1164 test 8 -le "$(build_option sizeof-long)"